%bcond_with gtk-doc

Summary:       A toolbox for accelerated data interchange and in-memory processing
Name:          libarrow
Version:       10.0.1
Release:       11%{?dist}
License:       Apache-2.0
URL:           https://arrow.apache.org/
Source0:       https://dist.apache.org/repos/dist/release/arrow/arrow-%{version}/apache-arrow-%{version}.tar.gz
Patch3001:     0001-arrow-10.0.1-add-support-for-loongarch64.patch

BuildRequires: cmake meson gcc-c++ ninja-build pkgconfig
BuildRequires: bison boost-devel brotli-devel bzip2-devel flex gflags-devel glog-devel
BuildRequires: grpc-devel grpc-plugins libzstd-devel lz4-devel openssl-devel python3-devel 
BuildRequires: python3-numpy xsimd-devel abseil-cpp-devel c-ares-devel thrift-devel 
BuildRequires: rapidjson-devel re2-devel snappy-devel utf8proc-devel zlib-devel liborc-devel 
BuildRequires: gobject-introspection-devel python3dist(cffi) python-Cython
%if %{with gtk-doc}
BuildRequires:	gtk-doc
%endif
Requires:      %{name}-doc = %{version}-%{release}

%description
Apache Arrow defines a language-independent columnar memory
format for flat and hierarchical data, organized for efficient
analytic operations on modern hardware like CPUs and GPUs. The
Arrow memory format also supports zero-copy reads for lightning-
fast data access without serialization overhead

%package doc
Summary:	Documentation files for Apache Arrow C++
BuildArch: noarch

%description doc
Documentation files for Apache Arrow C++.

%package devel
Summary:	Libraries and header files for Apache Arrow C++
Requires:	%{name} = %{version}-%{release}
Requires:	brotli-devel bzip2-devel libzstd-devel lz4-devel openssl-devel rapidjson-devel 
Requires:	re2-devel snappy-devel utf8proc-devel zlib-devel

%description devel
Libraries and header files for Apache Arrow C++.

%package dataset-libs
Summary:	C++ library to read and write semantic datasets
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-doc = %{version}-%{release}

%description dataset-libs
This package contains the libraries for Apache Arrow dataset.

%package dataset-devel
Summary:	Libraries and header files for Apache Arrow dataset
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-dataset-libs = %{version}-%{release}

%description dataset-devel
Libraries and header files for Apache Arrow dataset.

%package flight-libs
Summary:	C++ library for fast data transport
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-doc = %{version}-%{release}
Requires:	openssl

%description flight-libs
This package contains the libraries for Apache Arrow Flight.

%package flight-devel
Summary:	Libraries and header files for Apache Arrow Flight
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-flight-libs = %{version}-%{release}

%description flight-devel
Libraries and header files for Apache Arrow Flight.

%package python-libs
Summary:	Python integration library for Apache Arrow
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-doc = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Requires:	python3-numpy

%description python-libs
This package contains the Python integration library for Apache Arrow.

%package python-devel
Summary:	Libraries and header files for Python integration library
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-devel = %{version}-%{release}
Requires:	%{name}-python-libs = %{version}-%{release}
Requires:	python3-devel

%description python-devel
Libraries and header files for Python integration library for Apache Arrow.

%package python-flight-libs
Summary:	Python integration library for Apache Arrow Flight
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-flight-libs = %{version}-%{release}
Requires:	%{name}-python-libs = %{version}-%{release}
Requires:	%{name}-doc = %{version}-%{release}

%description python-flight-libs
This package contains the Python integration library for Apache Arrow Flight.

%package python-flight-devel
Summary:	Libraries and header files for Python integration
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-flight-devel = %{version}-%{release}
Requires:	%{name}-python-devel = %{version}-%{release}
Requires:	%{name}-python-flight-libs = %{version}-%{release}

%description python-flight-devel
Libraries and header files for Python integration library for
Apache Arrow Flight.

%package -n parquet-libs
Summary:	Runtime libraries for Apache Parquet C++
Requires:	boost-program-options
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-doc = %{version}-%{release}
Requires:	openssl

%description -n parquet-libs
This package contains the libraries for Apache Parquet C++.

%package -n parquet-libs-devel
Summary:	Libraries and header files for Apache Parquet C++
Requires:	%{name} = %{version}-%{release}
Requires:	parquet-libs = %{version}-%{release}
Requires:	zlib-devel

%description -n parquet-libs-devel
Libraries and header files for Apache Parquet C++.

%package glib-libs
Summary:	Runtime libraries for Apache Arrow GLib
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-doc = %{version}-%{release}

%description glib-libs
This package contains the libraries for Apache Arrow GLib.

%package glib-devel
Summary:	Libraries and header files for Apache Arrow GLib
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-devel = %{version}-%{release}
Requires:	%{name}-glib-libs = %{version}-%{release}
Requires:	glib2-devel gobject-introspection-devel

%description glib-devel
Libraries and header files for Apache Arrow GLib.

%if %{with gtk-doc}
%package glib-doc
Summary:	Documentation for Apache Arrow GLib

%description glib-doc
Documentation for Apache Arrow GLib.
%endif

%package dataset-glib-libs
Summary:	Runtime libraries for Apache Arrow dataset GLib
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-dataset-libs = %{version}-%{release}
Requires:	%{name}-glib-libs = %{version}-%{release}
Requires:	%{name}-doc = %{version}-%{release}

%description dataset-glib-libs
This package contains the libraries for Apache Arrow dataset GLib.

%package dataset-glib-devel
Summary:	Libraries and header files for Apache Arrow dataset GLib
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-dataset-devel = %{version}-%{release}
Requires:	%{name}-glib-devel = %{version}-%{release}
Requires:	%{name}-dataset-glib-libs = %{version}-%{release}

%description dataset-glib-devel
Libraries and header files for Apache Arrow dataset GLib.

%if %{with gtk-doc}
%package dataset-glib-doc
Summary:	Documentation for Apache Arrow dataset GLib

%description dataset-glib-doc
Documentation for Apache Arrow dataset GLib.
%endif

%package -n parquet-glib-libs
Summary:	Runtime libraries for Apache Parquet GLib
Requires:	%{name} = %{version}-%{release}
Requires:	parquet-libs = %{version}-%{release}
Requires:	%{name}-glib-libs = %{version}-%{release}
Requires:	%{name}-doc = %{version}-%{release}

%description -n parquet-glib-libs
This package contains the libraries for Apache Parquet GLib.

%package -n parquet-glib-devel
Summary:	Libraries and header files for Apache Parquet GLib
Requires:	%{name} = %{version}-%{release}
Requires:	parquet-libs-devel = %{version}-%{release}
Requires:	parquet-glib-libs = %{version}-%{release}
Requires:	%{name}-glib-devel = %{version}-%{release}

%description -n parquet-glib-devel
Libraries and header files for Apache Parquet GLib.

%if %{with gtk-doc}
%package -n parquet-glib-doc
Summary:	Documentation for Apache Parquet GLib

%description -n parquet-glib-doc
Documentation for Apache Parquet GLib.
%endif

%package -n python3-pyarrow
Summary: Python library for Apache Arrow

%description -n python3-pyarrow
Python library for Apache Arrow

%package -n python3-pyarrow-devel
Summary: Development files for python3-pyarrow
Requires:       python3-pyarrow = %{version}-%{release}

%description -n python3-pyarrow-devel
Development files for python3-pyarrow


%prep
%autosetup -p1 -n apache-arrow-%{version}
sed -r -i 's/(oldest-supported-)(numpy)/\2/' python/pyproject.toml

%generate_buildrequires
pushd python >/dev/null
%pyproject_buildrequires
popd >/dev/null

%build
pushd cpp
%cmake \
  -DARROW_FLIGHT:BOOL=ON \
  -DARROW_ORC=ON \
  -DARROW_PARQUET:BOOL=ON \
  -DARROW_PYTHON:BOOL=ON \
  -DARROW_JEMALLOC:BOOL=OFF \
  -DARROW_SIMD_LEVEL:STRING='NONE' \
  -DGRPC_SOURCE="SYSTEM" \
  -Dxsimd_SOURCE="SYSTEM" \
  -DARROW_WITH_BROTLI:BOOL=ON \
  -DARROW_WITH_BZ2:BOOL=ON \
  -DARROW_WITH_LZ4:BOOL=ON \
  -DARROW_WITH_SNAPPY:BOOL=ON \
  -DARROW_WITH_ZLIB:BOOL=ON \
  -DARROW_WITH_ZSTD:BOOL=ON \
  -DARROW_USE_XSIMD:BOOL=ON \
  -DARROW_BUILD_STATIC:BOOL=OFF \
  -DCMAKE_BUILD_TYPE=RelWithDebInfo \
  -DCMAKE_COLOR_MAKEFILE:BOOL=OFF \
  -DARROW_USE_CCACHE:BOOL=OFF \
  -DCMAKE_UNITY_BUILD:BOOL=ON \
  -DPARQUET_REQUIRE_ENCRYPTION:BOOL=ON \
  -DPythonInterp_FIND_VERSION:BOOL=ON \
  -DPythonInterp_FIND_VERSION_MAJOR=3 \
  -GNinja

export VERBOSE=1
export GCC_COLORS=
%cmake_build
popd

pushd c_glib
%meson \
  -Darrow_cpp_build_dir=../cpp/%{_vpath_builddir} \
  -Darrow_cpp_build_type=relwithdebinfo \
%if %{with gtk-doc}
  -Dgtk_doc=true
%else
  -Dgtk_doc=false
%endif
%meson_build
popd

pushd cpp
DESTDIR="/tmp" %__cmake --install "%{__cmake_builddir}"
popd

pushd python
export \
  CMAKE_PREFIX_PATH=/tmp/usr \
  PYARROW_BUNDLE_ARROW_CPP_HEADERS=1 \
  PYARROW_BUNDLE_PLASMA_EXECUTABLE=0 \
  PYARROW_WITH_DATASET=1 \
  PYARROW_WITH_FLIGHT=1 \
  PYARROW_WITH_PARQUET=1 \
  PYARROW_WITH_PARQUET_ENCRYPTION=1 \
  PYARROW_PARALLEL=%{_smp_build_ncpus} \
  PYARROW_INSTALL_TESTS=0
%pyproject_wheel
popd
rm -rf /tmp/usr


%install
pushd python
export PYARROW_INSTALL_TESTS=0
%pyproject_install
%pyproject_save_files pyarrow
mkdir -p %{buildroot}%{_libdir}/cmake/ArrowPython
install build/dist/lib/cmake/ArrowPython/ArrowPythonConfig.cmake %{buildroot}%{_libdir}/cmake/ArrowPython/
install build/dist/lib/cmake/ArrowPython/ArrowPythonConfigVersion.cmake %{buildroot}%{_libdir}/cmake/ArrowPython/
install build/dist/lib/cmake/ArrowPython/ArrowPythonTargets.cmake %{buildroot}%{_libdir}/cmake/ArrowPython/
install build/dist/lib/cmake/ArrowPython/ArrowPythonTargets-release.cmake %{buildroot}%{_libdir}/cmake/ArrowPython/
mkdir -p %{buildroot}%{_libdir}/cmake/ArrowPythonFlight
install build/dist/lib/cmake/ArrowPythonFlight/ArrowPythonFlightConfig.cmake %{buildroot}%{_libdir}/cmake/ArrowPythonFlight/
install build/dist/lib/cmake/ArrowPythonFlight/ArrowPythonFlightConfigVersion.cmake %{buildroot}%{_libdir}/cmake/ArrowPythonFlight/
install build/dist/lib/cmake/ArrowPythonFlight/ArrowPythonFlightTargets.cmake %{buildroot}%{_libdir}/cmake/ArrowPythonFlight/
install build/dist/lib/cmake/ArrowPythonFlight/ArrowPythonFlightTargets-release.cmake %{buildroot}%{_libdir}/cmake/ArrowPythonFlight/
mkdir -p %{buildroot}%{_libdir}/pkgconfig
install build/dist/lib/pkgconfig/arrow-python.pc %{buildroot}%{_libdir}/pkgconfig/
install build/dist/lib/pkgconfig/arrow-python-flight.pc %{buildroot}%{_libdir}/pkgconfig/
popd

pushd c_glib
%meson_install
popd

pushd cpp
%cmake_install
popd


%files
%{_libdir}/libarrow.so.*

%files doc
%license LICENSE.txt
%doc README.md NOTICE.txt
%exclude %{_docdir}/arrow/

%files devel
%dir %{_includedir}/arrow/
%{_includedir}/arrow/*
%exclude %{_includedir}/arrow/dataset/
%exclude %{_includedir}/arrow/flight/
%exclude %{_includedir}/arrow-flight-glib
%exclude %{_libdir}/cmake/Arrow/FindBrotli.cmake
%exclude %{_libdir}/cmake/Arrow/Findlz4Alt.cmake
%exclude %{_libdir}/cmake/Arrow/FindORC.cmake
%exclude %{_libdir}/cmake/Arrow/FindSnappyAlt.cmake
%exclude %{_libdir}/cmake/Arrow/FindgRPCAlt.cmake
%exclude %{_libdir}/cmake/Arrow/Findre2Alt.cmake
%exclude %{_libdir}/cmake/Arrow/Findutf8proc.cmake
%exclude %{_libdir}/cmake/Arrow/FindzstdAlt.cmake
%exclude %{_libdir}/cmake/Arrow/FindThrift.cmake
%exclude %{_libdir}/cmake/Arrow/FindOpenSSLAlt.cmake
%exclude %{_libdir}/cmake/Arrow/FindProtobufAlt.cmake
%dir %{_libdir}/cmake/Arrow/
%{_libdir}/cmake/Arrow/ArrowConfig*.cmake
%{_libdir}/cmake/Arrow/ArrowOptions.cmake
%{_libdir}/cmake/Arrow/ArrowTargets*.cmake
%{_libdir}/cmake/Arrow/arrow-config.cmake
%{_libdir}/libarrow.so
%{_libdir}/pkgconfig/arrow-compute.pc
%{_libdir}/pkgconfig/arrow-csv.pc
%{_libdir}/pkgconfig/arrow-filesystem.pc
%{_libdir}/pkgconfig/arrow-json.pc
%{_libdir}/pkgconfig/arrow-orc.pc
%{_libdir}/pkgconfig/arrow.pc
%{_datadir}/arrow/gdb/gdb_arrow.py
%{_datadir}/gdb/auto-load/usr/lib64/libarrow.so.*-gdb.py

%files dataset-libs
%{_libdir}/libarrow_dataset.so.*

%files dataset-devel
%dir %{_includedir}/arrow/dataset/
%{_includedir}/arrow/dataset/*
%{_libdir}/cmake/ArrowDataset/*.cmake
%{_libdir}/libarrow_dataset.so
%{_libdir}/pkgconfig/arrow-dataset.pc

%files flight-libs
%{_libdir}/libarrow_flight.so.*
%{_libdir}/libarrow-flight-glib.so.*
%dir %{_libdir}/girepository-1.0/
%{_libdir}/girepository-1.0/ArrowFlight-1.0.typelib

%files flight-devel
%dir %{_includedir}/arrow/flight/
%{_includedir}/arrow/flight/*
%dir %{_includedir}/arrow-flight-glib/
%{_includedir}/arrow-flight-glib/*
%{_libdir}/cmake/ArrowFlight/*.cmake
%{_libdir}/libarrow_flight.so
%{_libdir}/libarrow-flight-glib.so
%{_libdir}/pkgconfig/arrow-flight.pc
%{_libdir}/pkgconfig/arrow-flight-glib.pc

%files python-libs
%{python3_sitearch}/pyarrow/libarrow_python.so.*

%files python-devel
%dir %{python3_sitearch}/pyarrow/include/arrow/python
%{python3_sitearch}/pyarrow/include/arrow/python/*
%exclude %{python3_sitearch}/pyarrow/include/arrow/python/flight.h
%dir %{_libdir}/cmake/ArrowPython
%{_libdir}/cmake/ArrowPython/ArrowPython*.cmake
%{python3_sitearch}/pyarrow/libarrow_python.so
%{_libdir}/pkgconfig/arrow-python.pc

%files python-flight-libs
%{python3_sitearch}/pyarrow/libarrow_python_flight.so.*

%files python-flight-devel
%{python3_sitearch}/pyarrow/include/arrow/python/flight.h
%dir %{_libdir}/cmake/ArrowPythonFlight
%{_libdir}/cmake/ArrowPythonFlight/ArrowPythonFlight*.cmake
%{python3_sitearch}/pyarrow/libarrow_python_flight.so
%{_libdir}/pkgconfig/arrow-python-flight.pc

%files -n parquet-libs
%{_libdir}/libparquet.so.*

%files -n parquet-libs-devel
%dir %{_includedir}/parquet/
%{_includedir}/parquet/*
%{_libdir}/cmake/Parquet/*.cmake
%{_libdir}/libparquet.so
%{_libdir}/pkgconfig/parquet*.pc

%files glib-libs
%{_libdir}/libarrow-glib.so.*
%dir %{_libdir}/girepository-1.0/
%{_libdir}/girepository-1.0/Arrow-1.0.typelib
%exclude %{_datadir}/doc/arrow-glib/*

%files glib-devel
%dir %{_includedir}/arrow-glib/
%{_includedir}/arrow-glib/*
%{_libdir}/libarrow-glib.so
%{_libdir}/pkgconfig/arrow-glib.pc
%{_libdir}/pkgconfig/arrow-orc-glib.pc
%dir %{_datadir}/arrow-glib/
%{_datadir}/arrow-glib/example/*
%dir %{_datadir}/gir-1.0/
%{_datadir}/gir-1.0/Arrow-1.0.gir
%{_datadir}/gir-1.0/ArrowFlight-1.0.gir

%if %{with gtk-doc}
%files glib-doc
%dir %{_datadir}/gtk-doc/
%dir %{_datadir}/gtk-doc/html/
%dir %{_datadir}/gtk-doc/html/arrow-glib/
%{_datadir}/gtk-doc/html/arrow-glib/*
%dir %{_datadir}/gtk-doc/html/arrow-flight-glib/
%{_datadir}/gtk-doc/html/arrow-flight-glib/*
%endif

%files dataset-glib-libs
%{_libdir}/libarrow-dataset-glib.so.*
%dir %{_libdir}/girepository-1.0/
%{_libdir}/girepository-1.0/ArrowDataset-1.0.typelib

%files dataset-glib-devel
%dir %{_includedir}/arrow-dataset-glib/
%{_includedir}/arrow-dataset-glib/*
%{_libdir}/libarrow-dataset-glib.so
%{_libdir}/pkgconfig/arrow-dataset-glib.pc
%dir %{_datadir}/gir-1.0/
%{_datadir}/gir-1.0/ArrowDataset-1.0.gir

%if %{with gtk-doc}
%files dataset-glib-doc
%dir %{_datadir}/gtk-doc/html/arrow-dataset-glib/
%{_datadir}/gtk-doc/html/arrow-dataset-glib/*
%endif

%files -n parquet-glib-libs
%{_libdir}/libparquet-glib.so.*
%dir %{_libdir}/girepository-1.0/
%{_libdir}/girepository-1.0/Parquet-1.0.typelib

%files -n parquet-glib-devel
%dir %{_includedir}/parquet-glib/
%{_includedir}/parquet-glib/*
%{_libdir}/libparquet-glib.so
%{_libdir}/pkgconfig/parquet-glib.pc
%dir %{_datadir}/gir-1.0/
%{_datadir}/gir-1.0/Parquet-1.0.gir

%if %{with gtk-doc}
%files -n parquet-glib-doc
%dir %{_datadir}/gtk-doc/html/parquet-glib/
%{_datadir}/gtk-doc/html/parquet-glib/*
%endif

%files -n python3-pyarrow -f %{pyproject_files}
%{_bindir}/plasma_store
%exclude %{python3_sitearch}/pyarrow/lib_api.h
%exclude %{python3_sitearch}/pyarrow/include

%files -n python3-pyarrow-devel
%{python3_sitearch}/pyarrow/lib_api.h
%{python3_sitearch}/pyarrow/include

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 10.0.1-11
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 10.0.1-10
- Rebuilt for loongarch release

* Fri Jun 14 2024 Pengda Dou <doupengda@loongson.cn> - 10.0.1-9
- [Type] other
- [DESC] add support for loongarch64

* Wed Sep 20 2023 Miaojun Dong <zoedong@tencent.com> - 10.0.1-8
- Rebuild for grpc-1.56.1

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 10.0.1-7
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 10.0.1-6
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Sep 07 2023 cunshunxia <cunshunxia@tencent.com> - 10.0.1-5
- build require Cython 0.29 instead of Cython3.

* Tue Aug 01 2023 rockerzhu rockerzhu@tencent.com - 10.0.1-4
- Rebuilt for boost 1.82.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 10.0.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 10.0.1-2
- Rebuilt for OpenCloudOS Stream 23

* Sun Dec 18 2022 Miaojun Dong <zoedong@tencent.com> - 10.0.1-1
- initial build
